' From "Curlicue Fractal" by Eric W. Weisstein.
' From MathWorld--A Wolfram Web Resource. http://mathworld.wolfram.com/CurlicueFractal.html 

Imports System.Math
Imports System.Drawing.Drawing2D

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents picCanvas As System.Windows.Forms.PictureBox
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents txtS As System.Windows.Forms.TextBox
    Friend WithEvents btnGo As System.Windows.Forms.Button
    Friend WithEvents cboS As System.Windows.Forms.ComboBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.picCanvas = New System.Windows.Forms.PictureBox
        Me.Label1 = New System.Windows.Forms.Label
        Me.txtS = New System.Windows.Forms.TextBox
        Me.btnGo = New System.Windows.Forms.Button
        Me.cboS = New System.Windows.Forms.ComboBox
        Me.SuspendLayout()
        '
        'picCanvas
        '
        Me.picCanvas.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.picCanvas.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.picCanvas.Location = New System.Drawing.Point(0, 24)
        Me.picCanvas.Name = "picCanvas"
        Me.picCanvas.Size = New System.Drawing.Size(638, 660)
        Me.picCanvas.TabIndex = 0
        Me.picCanvas.TabStop = False
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(0, 0)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(24, 16)
        Me.Label1.TabIndex = 1
        Me.Label1.Text = "S ="
        '
        'txtS
        '
        Me.txtS.Location = New System.Drawing.Point(24, 0)
        Me.txtS.Name = "txtS"
        Me.txtS.Size = New System.Drawing.Size(80, 20)
        Me.txtS.TabIndex = 2
        Me.txtS.Text = "3.14159265"
        '
        'btnGo
        '
        Me.btnGo.Location = New System.Drawing.Point(112, 0)
        Me.btnGo.Name = "btnGo"
        Me.btnGo.Size = New System.Drawing.Size(32, 23)
        Me.btnGo.TabIndex = 3
        Me.btnGo.Text = "Go"
        '
        'cboS
        '
        Me.cboS.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cboS.Items.AddRange(New Object() {"Pi", "ln(2)", "e", "Sqrt(2)", "Sqrt(3)", "Sqrt(5)", "Lambda", "Golden Ratio", "Feigenbaum"})
        Me.cboS.Location = New System.Drawing.Point(152, 0)
        Me.cboS.Name = "cboS"
        Me.cboS.Size = New System.Drawing.Size(112, 21)
        Me.cboS.TabIndex = 4
        '
        'Form1
        '
        Me.AcceptButton = Me.btnGo
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(640, 685)
        Me.Controls.Add(Me.cboS)
        Me.Controls.Add(Me.btnGo)
        Me.Controls.Add(Me.txtS)
        Me.Controls.Add(Me.Label1)
        Me.Controls.Add(Me.picCanvas)
        Me.Name = "Form1"
        Me.Text = "Form1"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub btnGo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGo.Click
        picCanvas.Invalidate()
    End Sub

    Private Sub picCanvas_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles picCanvas.Resize
        picCanvas.Invalidate()
    End Sub

    Private Sub picCanvas_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles picCanvas.Paint
        DrawCurlicue(e.Graphics)
    End Sub

    Private Sub DrawCurlicue(ByVal gr As Graphics)
        Const SCALE As Integer = 2
        gr.ScaleTransform( _
            SCALE, _
            SCALE, _
            MatrixOrder.Append)
        gr.TranslateTransform( _
            picCanvas.ClientSize.Width \ 2, _
            picCanvas.ClientSize.Width \ 2, _
            MatrixOrder.Append)

        Dim s As Single = Single.Parse(txtS.Text)

        Dim theta As Single = 0
        Dim phi As Single = 0
        Dim x0, y0, x1, y1 As Single
        x0 = 0
        y0 = 0
        Dim thin_pen As New Pen(Color.Black, 0)
        For i As Integer = 1 To 10000
            x1 = x0 + Cos(phi)
            y1 = y0 + Sin(phi)
            gr.DrawLine(thin_pen, x0, -y0, x1, -y1)
            x0 = x1
            y0 = y1

            phi = (theta + phi) Mod (2 * PI)
            theta = (theta + 2 * PI * s) Mod (2 * PI)
        Next i
        thin_pen.Dispose()
    End Sub

    Private Sub cboS_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboS.SelectedIndexChanged
        Select Case cboS.Text.ToLower
            Case "pi"
                txtS.Text = PI.ToString
            Case "ln(2)"
                txtS.Text = Log(2).ToString
            Case "e"
                txtS.Text = Math.E.ToString
            Case "sqrt(2)"
                txtS.Text = Sqrt(2).ToString
            Case "sqrt(3)"
                txtS.Text = Sqrt(3).ToString
            Case "sqrt(5)"
                txtS.Text = Sqrt(5).ToString
            Case "lambda"
                txtS.Text = "0.577215664901532860606512090082402431042"
            Case "golden ratio"
                txtS.Text = "1.618033988749894848204586834365638117720"
            Case "feigenbaum"
                txtS.Text = "4.6692016091029906718532038204662016172581855774757686327456513430041343302113147371386897440239480138"
        End Select
        picCanvas.Invalidate()
    End Sub
End Class
